﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.801
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim oMediaProjectionScreenShot As MediaProjectionScreenShot
	Dim oBitmap As Bitmap
	Dim oTimer As Timer
	Dim oInterval As Int = 3000
	Dim oNotification As Notification
	Dim oStopAfterToken As Boolean = False
	Dim oCount As Int = 0
	Dim oNow As Long
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
	oMediaProjectionScreenShot.Initialize("oMediaProjectionScreenShot")
	oTimer.Initialize("oTimer", oInterval)																'Timer for Screenshotting
	oTimer.Enabled = False
	
	oNotification.Initialize																			'Notification to return to MainActivity
	oNotification.Icon = "icon"
	oNotification.OnGoingEvent = True
	oNotification.Sound = False
	oNotification.Vibrate = False
	oNotification.SetInfo("Click to return MainActivity.", "", Main)

End Sub

Sub Service_Start (StartingIntent As Intent)
	Service.StopAutomaticForeground																		'Starter service can start in the foreground state in some edge cases.
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub

Sub Start_Working
	Service.StartForeground(1, oNotification)
	Log("Start_Working")
	oCount = 0
	oTimer.Enabled = True
End Sub

Sub Stop_Working()
	Try
		oMediaProjectionScreenShot.stop																	'stop the mediaprojection and hide the notification area icon
	Catch
		Log(LastException)
	End Try
End Sub

Sub oMediaProjectionScreenShot_ImageReady(bmp As Object)
	oBitmap = bmp
	If oBitmap <> Null Then
		oCount = oCount + 1
		ToastMessageShow("#" & oCount & ": " & oBitmap.Width & "*" & oBitmap.Height & " Time Consume: " & (DateTime.Now - oNow), True)
		'Save_Photo(oBitmap, "screen.png")																'see the result picture in the root folder of the device
	Else
		ToastMessageShow("Null Bitmap", True)
	End If
End Sub

Sub Save_Photo (Pt As Bitmap, filename As String)
	Dim Out As OutputStream
	Out = File.OpenOutput(File.DirRootExternal, filename, False)
	Pt.WriteToStream(Out, 30, "JPEG")
	Out.Close
End Sub

Sub oTimer_Tick
	Log("oTimer_Tick")
	oNow = DateTime.Now
	oMediaProjectionScreenShot.init(0, 0, 0)															'0 for auto-calculation of each parameter
	'oStopAfterToken:
	'True:  stop the mProjection object after one screen capture and create it again the next time
	'False: no stop, mProjection object will keep running in the background after created
	oMediaProjectionScreenShot.TakeScreenshot(oStopAfterToken)											'make one screenshot. 
End Sub